// <auto-generated>
//     Generated by the protocol buffer compiler.  DO NOT EDIT!
//     source: telemetry/HarmonicDistortion.proto
// </auto-generated>
#pragma warning disable 1591, 0612, 3021, 8981
#region Designer generated code

using pb = global::Google.Protobuf;
using pbc = global::Google.Protobuf.Collections;
using pbr = global::Google.Protobuf.Reflection;
using scg = global::System.Collections.Generic;
namespace Electricity {

  /// <summary>Holder for reflection information generated from telemetry/HarmonicDistortion.proto</summary>
  public static partial class HarmonicDistortionReflection {

    #region Descriptor
    /// <summary>File descriptor for telemetry/HarmonicDistortion.proto</summary>
    public static pbr::FileDescriptor Descriptor {
      get { return descriptor; }
    }
    private static pbr::FileDescriptor descriptor;

    static HarmonicDistortionReflection() {
      byte[] descriptorData = global::System.Convert.FromBase64String(
          string.Concat(
            "CiJ0ZWxlbWV0cnkvSGFybW9uaWNEaXN0b3J0aW9uLnByb3RvEgtlbGVjdHJp",
            "Y2l0eSKKBAoSSGFybW9uaWNEaXN0b3J0aW9uEhQKB2N1cnJlbnQYASABKAlI",
            "AIgBARIUCgd2b2x0YWdlGAIgASgJSAGIAQESFgoJYXN5bW1ldHJ5GAMgASgJ",
            "SAKIAQESHgoRZGlzdG9ydGlvbl9mYWN0b3IYBCABKAlIA4gBARI/CgtzYW1w",
            "bGVfdHlwZRgUIAEoDjIqLmVsZWN0cmljaXR5Lkhhcm1vbmljRGlzdG9ydGlv",
            "bi5TYW1wbGVUeXBlEjQKBXBoYXNlGBUgASgOMiUuZWxlY3RyaWNpdHkuSGFy",
            "bW9uaWNEaXN0b3J0aW9uLlBoYXNlEiAKE2hhcm1vbmljX2lkZW50aWZpZXIY",
            "FiABKAlIBIgBASInCgpTYW1wbGVUeXBlEgcKA0FWRxAAEgcKA01JThABEgcK",
            "A01BWBACInoKBVBoYXNlEgYKAkwxEAASBgoCTDIQARIGCgJMMxACEggKBEwx",
            "X04QAxIICgRMMl9OEAQSCAoETDNfThAFEggKBFBFX04QBhIFCgFOEAcSCQoF",
            "TDFfTDIQCBIJCgVMMl9MMxAJEgkKBUwzX0wxEAoSCQoFVE9UQUwQC0IKCghf",
            "Y3VycmVudEIKCghfdm9sdGFnZUIMCgpfYXN5bW1ldHJ5QhQKEl9kaXN0b3J0",
            "aW9uX2ZhY3RvckIWChRfaGFybW9uaWNfaWRlbnRpZmllckJ+Chtjb20uY29k",
            "aWJseS5tb2RlbC50ZWxlbWV0cnlCF0hhcm1vbmljRGlzdG9ydGlvblByb3Rv",
            "ygIbRG9tYWluTW9kZWxcUHJvdG9cVGVsZW1ldHJ54gInRG9tYWluTW9kZWxc",
            "UHJvdG9cVGVsZW1ldHJ5XEdQQk1ldGFkYXRhYgZwcm90bzM="));
      descriptor = pbr::FileDescriptor.FromGeneratedCode(descriptorData,
          new pbr::FileDescriptor[] { },
          new pbr::GeneratedClrTypeInfo(null, null, new pbr::GeneratedClrTypeInfo[] {
            new pbr::GeneratedClrTypeInfo(typeof(global::Electricity.HarmonicDistortion), global::Electricity.HarmonicDistortion.Parser, new[]{ "Current", "Voltage", "Asymmetry", "DistortionFactor", "SampleType", "Phase", "HarmonicIdentifier" }, new[]{ "Current", "Voltage", "Asymmetry", "DistortionFactor", "HarmonicIdentifier" }, new[]{ typeof(global::Electricity.HarmonicDistortion.Types.SampleType), typeof(global::Electricity.HarmonicDistortion.Types.Phase) }, null, null)
          }));
    }
    #endregion

  }
  #region Messages
  public sealed partial class HarmonicDistortion : pb::IMessage<HarmonicDistortion>
  #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
      , pb::IBufferMessage
  #endif
  {
    private static readonly pb::MessageParser<HarmonicDistortion> _parser = new pb::MessageParser<HarmonicDistortion>(() => new HarmonicDistortion());
    private pb::UnknownFieldSet _unknownFields;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public static pb::MessageParser<HarmonicDistortion> Parser { get { return _parser; } }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public static pbr::MessageDescriptor Descriptor {
      get { return global::Electricity.HarmonicDistortionReflection.Descriptor.MessageTypes[0]; }
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    pbr::MessageDescriptor pb::IMessage.Descriptor {
      get { return Descriptor; }
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public HarmonicDistortion() {
      OnConstruction();
    }

    partial void OnConstruction();

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public HarmonicDistortion(HarmonicDistortion other) : this() {
      current_ = other.current_;
      voltage_ = other.voltage_;
      asymmetry_ = other.asymmetry_;
      distortionFactor_ = other.distortionFactor_;
      sampleType_ = other.sampleType_;
      phase_ = other.phase_;
      harmonicIdentifier_ = other.harmonicIdentifier_;
      _unknownFields = pb::UnknownFieldSet.Clone(other._unknownFields);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public HarmonicDistortion Clone() {
      return new HarmonicDistortion(this);
    }

    /// <summary>Field number for the "current" field.</summary>
    public const int CurrentFieldNumber = 1;
    private string current_;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public string Current {
      get { return current_ ?? ""; }
      set {
        current_ = pb::ProtoPreconditions.CheckNotNull(value, "value");
      }
    }
    /// <summary>Gets whether the "current" field is set</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public bool HasCurrent {
      get { return current_ != null; }
    }
    /// <summary>Clears the value of the "current" field</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void ClearCurrent() {
      current_ = null;
    }

    /// <summary>Field number for the "voltage" field.</summary>
    public const int VoltageFieldNumber = 2;
    private string voltage_;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public string Voltage {
      get { return voltage_ ?? ""; }
      set {
        voltage_ = pb::ProtoPreconditions.CheckNotNull(value, "value");
      }
    }
    /// <summary>Gets whether the "voltage" field is set</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public bool HasVoltage {
      get { return voltage_ != null; }
    }
    /// <summary>Clears the value of the "voltage" field</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void ClearVoltage() {
      voltage_ = null;
    }

    /// <summary>Field number for the "asymmetry" field.</summary>
    public const int AsymmetryFieldNumber = 3;
    private string asymmetry_;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public string Asymmetry {
      get { return asymmetry_ ?? ""; }
      set {
        asymmetry_ = pb::ProtoPreconditions.CheckNotNull(value, "value");
      }
    }
    /// <summary>Gets whether the "asymmetry" field is set</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public bool HasAsymmetry {
      get { return asymmetry_ != null; }
    }
    /// <summary>Clears the value of the "asymmetry" field</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void ClearAsymmetry() {
      asymmetry_ = null;
    }

    /// <summary>Field number for the "distortion_factor" field.</summary>
    public const int DistortionFactorFieldNumber = 4;
    private string distortionFactor_;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public string DistortionFactor {
      get { return distortionFactor_ ?? ""; }
      set {
        distortionFactor_ = pb::ProtoPreconditions.CheckNotNull(value, "value");
      }
    }
    /// <summary>Gets whether the "distortion_factor" field is set</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public bool HasDistortionFactor {
      get { return distortionFactor_ != null; }
    }
    /// <summary>Clears the value of the "distortion_factor" field</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void ClearDistortionFactor() {
      distortionFactor_ = null;
    }

    /// <summary>Field number for the "sample_type" field.</summary>
    public const int SampleTypeFieldNumber = 20;
    private global::Electricity.HarmonicDistortion.Types.SampleType sampleType_ = global::Electricity.HarmonicDistortion.Types.SampleType.Avg;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public global::Electricity.HarmonicDistortion.Types.SampleType SampleType {
      get { return sampleType_; }
      set {
        sampleType_ = value;
      }
    }

    /// <summary>Field number for the "phase" field.</summary>
    public const int PhaseFieldNumber = 21;
    private global::Electricity.HarmonicDistortion.Types.Phase phase_ = global::Electricity.HarmonicDistortion.Types.Phase.L1;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public global::Electricity.HarmonicDistortion.Types.Phase Phase {
      get { return phase_; }
      set {
        phase_ = value;
      }
    }

    /// <summary>Field number for the "harmonic_identifier" field.</summary>
    public const int HarmonicIdentifierFieldNumber = 22;
    private string harmonicIdentifier_;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public string HarmonicIdentifier {
      get { return harmonicIdentifier_ ?? ""; }
      set {
        harmonicIdentifier_ = pb::ProtoPreconditions.CheckNotNull(value, "value");
      }
    }
    /// <summary>Gets whether the "harmonic_identifier" field is set</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public bool HasHarmonicIdentifier {
      get { return harmonicIdentifier_ != null; }
    }
    /// <summary>Clears the value of the "harmonic_identifier" field</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void ClearHarmonicIdentifier() {
      harmonicIdentifier_ = null;
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public override bool Equals(object other) {
      return Equals(other as HarmonicDistortion);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public bool Equals(HarmonicDistortion other) {
      if (ReferenceEquals(other, null)) {
        return false;
      }
      if (ReferenceEquals(other, this)) {
        return true;
      }
      if (Current != other.Current) return false;
      if (Voltage != other.Voltage) return false;
      if (Asymmetry != other.Asymmetry) return false;
      if (DistortionFactor != other.DistortionFactor) return false;
      if (SampleType != other.SampleType) return false;
      if (Phase != other.Phase) return false;
      if (HarmonicIdentifier != other.HarmonicIdentifier) return false;
      return Equals(_unknownFields, other._unknownFields);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public override int GetHashCode() {
      int hash = 1;
      if (HasCurrent) hash ^= Current.GetHashCode();
      if (HasVoltage) hash ^= Voltage.GetHashCode();
      if (HasAsymmetry) hash ^= Asymmetry.GetHashCode();
      if (HasDistortionFactor) hash ^= DistortionFactor.GetHashCode();
      if (SampleType != global::Electricity.HarmonicDistortion.Types.SampleType.Avg) hash ^= SampleType.GetHashCode();
      if (Phase != global::Electricity.HarmonicDistortion.Types.Phase.L1) hash ^= Phase.GetHashCode();
      if (HasHarmonicIdentifier) hash ^= HarmonicIdentifier.GetHashCode();
      if (_unknownFields != null) {
        hash ^= _unknownFields.GetHashCode();
      }
      return hash;
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public override string ToString() {
      return pb::JsonFormatter.ToDiagnosticString(this);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void WriteTo(pb::CodedOutputStream output) {
    #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
      output.WriteRawMessage(this);
    #else
      if (HasCurrent) {
        output.WriteRawTag(10);
        output.WriteString(Current);
      }
      if (HasVoltage) {
        output.WriteRawTag(18);
        output.WriteString(Voltage);
      }
      if (HasAsymmetry) {
        output.WriteRawTag(26);
        output.WriteString(Asymmetry);
      }
      if (HasDistortionFactor) {
        output.WriteRawTag(34);
        output.WriteString(DistortionFactor);
      }
      if (SampleType != global::Electricity.HarmonicDistortion.Types.SampleType.Avg) {
        output.WriteRawTag(160, 1);
        output.WriteEnum((int) SampleType);
      }
      if (Phase != global::Electricity.HarmonicDistortion.Types.Phase.L1) {
        output.WriteRawTag(168, 1);
        output.WriteEnum((int) Phase);
      }
      if (HasHarmonicIdentifier) {
        output.WriteRawTag(178, 1);
        output.WriteString(HarmonicIdentifier);
      }
      if (_unknownFields != null) {
        _unknownFields.WriteTo(output);
      }
    #endif
    }

    #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    void pb::IBufferMessage.InternalWriteTo(ref pb::WriteContext output) {
      if (HasCurrent) {
        output.WriteRawTag(10);
        output.WriteString(Current);
      }
      if (HasVoltage) {
        output.WriteRawTag(18);
        output.WriteString(Voltage);
      }
      if (HasAsymmetry) {
        output.WriteRawTag(26);
        output.WriteString(Asymmetry);
      }
      if (HasDistortionFactor) {
        output.WriteRawTag(34);
        output.WriteString(DistortionFactor);
      }
      if (SampleType != global::Electricity.HarmonicDistortion.Types.SampleType.Avg) {
        output.WriteRawTag(160, 1);
        output.WriteEnum((int) SampleType);
      }
      if (Phase != global::Electricity.HarmonicDistortion.Types.Phase.L1) {
        output.WriteRawTag(168, 1);
        output.WriteEnum((int) Phase);
      }
      if (HasHarmonicIdentifier) {
        output.WriteRawTag(178, 1);
        output.WriteString(HarmonicIdentifier);
      }
      if (_unknownFields != null) {
        _unknownFields.WriteTo(ref output);
      }
    }
    #endif

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public int CalculateSize() {
      int size = 0;
      if (HasCurrent) {
        size += 1 + pb::CodedOutputStream.ComputeStringSize(Current);
      }
      if (HasVoltage) {
        size += 1 + pb::CodedOutputStream.ComputeStringSize(Voltage);
      }
      if (HasAsymmetry) {
        size += 1 + pb::CodedOutputStream.ComputeStringSize(Asymmetry);
      }
      if (HasDistortionFactor) {
        size += 1 + pb::CodedOutputStream.ComputeStringSize(DistortionFactor);
      }
      if (SampleType != global::Electricity.HarmonicDistortion.Types.SampleType.Avg) {
        size += 2 + pb::CodedOutputStream.ComputeEnumSize((int) SampleType);
      }
      if (Phase != global::Electricity.HarmonicDistortion.Types.Phase.L1) {
        size += 2 + pb::CodedOutputStream.ComputeEnumSize((int) Phase);
      }
      if (HasHarmonicIdentifier) {
        size += 2 + pb::CodedOutputStream.ComputeStringSize(HarmonicIdentifier);
      }
      if (_unknownFields != null) {
        size += _unknownFields.CalculateSize();
      }
      return size;
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void MergeFrom(HarmonicDistortion other) {
      if (other == null) {
        return;
      }
      if (other.HasCurrent) {
        Current = other.Current;
      }
      if (other.HasVoltage) {
        Voltage = other.Voltage;
      }
      if (other.HasAsymmetry) {
        Asymmetry = other.Asymmetry;
      }
      if (other.HasDistortionFactor) {
        DistortionFactor = other.DistortionFactor;
      }
      if (other.SampleType != global::Electricity.HarmonicDistortion.Types.SampleType.Avg) {
        SampleType = other.SampleType;
      }
      if (other.Phase != global::Electricity.HarmonicDistortion.Types.Phase.L1) {
        Phase = other.Phase;
      }
      if (other.HasHarmonicIdentifier) {
        HarmonicIdentifier = other.HarmonicIdentifier;
      }
      _unknownFields = pb::UnknownFieldSet.MergeFrom(_unknownFields, other._unknownFields);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void MergeFrom(pb::CodedInputStream input) {
    #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
      input.ReadRawMessage(this);
    #else
      uint tag;
      while ((tag = input.ReadTag()) != 0) {
        switch(tag) {
          default:
            _unknownFields = pb::UnknownFieldSet.MergeFieldFrom(_unknownFields, input);
            break;
          case 10: {
            Current = input.ReadString();
            break;
          }
          case 18: {
            Voltage = input.ReadString();
            break;
          }
          case 26: {
            Asymmetry = input.ReadString();
            break;
          }
          case 34: {
            DistortionFactor = input.ReadString();
            break;
          }
          case 160: {
            SampleType = (global::Electricity.HarmonicDistortion.Types.SampleType) input.ReadEnum();
            break;
          }
          case 168: {
            Phase = (global::Electricity.HarmonicDistortion.Types.Phase) input.ReadEnum();
            break;
          }
          case 178: {
            HarmonicIdentifier = input.ReadString();
            break;
          }
        }
      }
    #endif
    }

    #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    void pb::IBufferMessage.InternalMergeFrom(ref pb::ParseContext input) {
      uint tag;
      while ((tag = input.ReadTag()) != 0) {
        switch(tag) {
          default:
            _unknownFields = pb::UnknownFieldSet.MergeFieldFrom(_unknownFields, ref input);
            break;
          case 10: {
            Current = input.ReadString();
            break;
          }
          case 18: {
            Voltage = input.ReadString();
            break;
          }
          case 26: {
            Asymmetry = input.ReadString();
            break;
          }
          case 34: {
            DistortionFactor = input.ReadString();
            break;
          }
          case 160: {
            SampleType = (global::Electricity.HarmonicDistortion.Types.SampleType) input.ReadEnum();
            break;
          }
          case 168: {
            Phase = (global::Electricity.HarmonicDistortion.Types.Phase) input.ReadEnum();
            break;
          }
          case 178: {
            HarmonicIdentifier = input.ReadString();
            break;
          }
        }
      }
    }
    #endif

    #region Nested types
    /// <summary>Container for nested types declared in the HarmonicDistortion message type.</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public static partial class Types {
      public enum SampleType {
        [pbr::OriginalName("AVG")] Avg = 0,
        [pbr::OriginalName("MIN")] Min = 1,
        [pbr::OriginalName("MAX")] Max = 2,
      }

      public enum Phase {
        [pbr::OriginalName("L1")] L1 = 0,
        [pbr::OriginalName("L2")] L2 = 1,
        [pbr::OriginalName("L3")] L3 = 2,
        [pbr::OriginalName("L1_N")] L1N = 3,
        [pbr::OriginalName("L2_N")] L2N = 4,
        [pbr::OriginalName("L3_N")] L3N = 5,
        [pbr::OriginalName("PE_N")] PeN = 6,
        [pbr::OriginalName("N")] N = 7,
        [pbr::OriginalName("L1_L2")] L1L2 = 8,
        [pbr::OriginalName("L2_L3")] L2L3 = 9,
        [pbr::OriginalName("L3_L1")] L3L1 = 10,
        [pbr::OriginalName("TOTAL")] Total = 11,
      }

    }
    #endregion

  }

  #endregion

}

#endregion Designer generated code
